package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.dao.custom.base.impl.FindConverterDao;
import com.jasamedika.medifirst2000.entities.PapInstruksiPerjanjian;
import com.jasamedika.medifirst2000.vo.PapInstruksiPerjanjianVO;

/**
 * Converter class PAPInstruksiPerjanjian
 * 
 * @author Askur
 */
@Component
public class PapInstruksiPerjanjianConverter extends FindConverterDao implements
		BaseVoConverter<PapInstruksiPerjanjianVO, PapInstruksiPerjanjian> {

	public PapInstruksiPerjanjian transferVOToModel(PapInstruksiPerjanjianVO vo, PapInstruksiPerjanjian model) {
		if (null == model)
			model = new PapInstruksiPerjanjian();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, PapInstruksiPerjanjian.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;

	}

	public List<PapInstruksiPerjanjianVO> transferListOfModelToListOfVO(List<PapInstruksiPerjanjian> models,
			List<PapInstruksiPerjanjianVO> vos) {
		if (null == vos)
			vos = new ArrayList<PapInstruksiPerjanjianVO>();

		if (null == models)
			return vos;

		for (PapInstruksiPerjanjian model : models) {
			PapInstruksiPerjanjianVO vo = new PapInstruksiPerjanjianVO();
			transferModelToVO(model, vo);
			vos.add(vo);
		}

		return vos;
	}

	public PapInstruksiPerjanjianVO transferModelToVO(PapInstruksiPerjanjian model, PapInstruksiPerjanjianVO vo) {
		if (null == vo)
			vo = new PapInstruksiPerjanjianVO();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, PapInstruksiPerjanjianVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
}
